package jp.gihyo.mitoma.careMedicalV01.model;

import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MedicalBean {
	private String memNo;
	private String memName;
	private String date;
	private String time;
	private String planNo;	
	private String bloodU;
	private String bloodL;
	private String pulse;
	private String height;
	private String weight;
	private String observ;
	private String helperCode;
	private String helperName;
	private MedDAOInterface medDAO;
	/* *********************************************
     * ftHgRXgN^(tB[h̏)
     ************************************************/
	public MedicalBean(){
		this.memNo="";
		this.memName="";
		this.date="";
		this.time="";
		this.planNo="";
		this.bloodU="";
		this.bloodL="";
		this.pulse="";
		this.height="";
		this.weight="";
		this.observ="";
		this.helperCode="";
		this.helperName="";		
	}
	/* *********************************************
     * CX^XRXgN^
     ************************************************/
	public MedicalBean(Context context){
		this();
		this.medDAO=new MedicalDAO(context);
	}
	/* *********************************************
     * w(CtCvԍ)CX^X
     ************************************************/
	public MedicalBean(Context context,String memNo,String date,String planNo){
		this(context);
		this.memNo=memNo;
		this.date=date;
		this.planNo=planNo;
		this.medInquiry(memNo, date, planNo);		
	}
	/* *********************************************
     * Zb^[
     ************************************************/
	public void setMemNo(String no){this.memNo=no;}
	public void setMemName(String name){this.memName=name;}
	public void setDate(String date){this.date=date;}
	public void setPlanNo(String no){this.planNo=no;}
	public void setTime(String time){this.time=time;}
	public void setBloodU(String data){this.bloodU=data;}
	public void setBloodL(String data){this.bloodL=data;}
	public void setPulse(String data){this.pulse=data;}
	public void setHeight(String data){this.height=data;}
	public void setWeight(String data){this.weight=data;}
	public void setObserv(String data){this.observ=data;}
	public void setHelperCode(String code){this.helperCode=code;}
	public void setHelperName(String name){this.helperName=name;}
	/* *********************************************
     * Qb^[
     ************************************************/
	public String getMemNo(){return this.memNo;}
	public String getMemName(){return this.memName;}
	public String getDate(){return this.date;}
	public String getPlanNo(){return this.planNo;}
	public String getTime(){return this.time;}
	public String getBloodU(){return this.bloodU;}
	public String getBloodL(){return this.bloodL;}
	public String getPulse(){return this.pulse;}
	public String getHeight(){return this.height;}
	public String getWeight(){return this.weight;}
	public String getObserv(){return this.observ;}
	public String getHelperCode(){return this.helperCode;}
	public String getHelperName(){return this.helperName;}
	/* *********************************************
     * Nf[^o^
     ************************************************/
	public int medRegist(){
		MedicalDTO dto=new MedicalDTO();
		//do^h~̂߁CUCOlNA(ʏ0)
		this.medDAO.deleteOne(this.memNo, this.date,this.planNo);
		//DTOɊi[
    	dto.setMemNo(this.memNo);
    	dto.setMemName(this.memName);
    	dto.setDate(this.date);
    	dto.setTime(this.time);
    	dto.setPlanNo(this.planNo);
    	dto.setBloodU(this.bloodU);
    	dto.setBloodL(this.bloodL);
    	dto.setPulse(this.pulse);
    	dto.setHeight(this.height);
    	dto.setWeight(this.weight);
    	dto.setObserv(this.observ);
    	this.medDAO.insertOne(dto);
		return 1;
	}
	/* *********************************************
     * Nf[^폜
     ************************************************/
	public int medDelete(){
		return this.medDAO.deleteOne(this.memNo, this.date, this.planNo);
	}
	/* *********************************************
     * Nf[^XV
     ************************************************/
	public int medUpdate(){
		MedicalDTO dto=new MedicalDTO();
    	dto.setMemNo(this.memNo);
    	dto.setMemName(this.memName);
    	dto.setDate(this.date);
    	dto.setTime(this.time);
    	dto.setPlanNo(this.planNo);
    	dto.setBloodU(this.bloodU);
    	dto.setBloodL(this.bloodL);
    	dto.setPulse(this.pulse);
    	dto.setHeight(this.height);
    	dto.setWeight(this.weight);
    	dto.setObserv(this.observ);
    	return this.medDAO.updateOne(dto);
	}
	/* *********************************************
     * Nf[^Ɖ
     ************************************************/
	public int medInquiry(String memNo,String date,String planNo){
		MedicalDTO dto=this.medDAO.selectOne(memNo, date, planNo);
		if(dto!=null){
			this.memNo=dto.getMemNo();
			this.memName=dto.getMemName();
			this.date=dto.getDate();
			this.time=dto.getTime();
			this.planNo=dto.getPlanNo();
			this.bloodU=dto.getBloodU();
			this.bloodL=dto.getBloodL();
			this.pulse=dto.getPulse();
			this.height=dto.getHeight();
			this.weight=dto.getWeight();
			this.observ=dto.getObserv();
			return 1;
		}else return 0;    	
	}
	/* *********************************************
     * Nf[^݂̔
     ************************************************/
	public boolean isCareExist(){
		if(this.memNo.equals("")||this.memName.equals(""))return false;
		else return true;
	}
}