package jp.gihyo.mitoma.careMember.model;

import java.io.Serializable;

import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberBean implements Serializable{
	private static final long serialVersionUID = 1L;
	private String memNo;
	private String memName;
	private String memGender;
	private String memBirthday;
	private String memPref;	
	private String memEmail;
	private String memTel;
	private String memLevel;
	private String memLatitude;
	private String memLongitude;
	private transient MemberDAOInterface memberDAO;
	public MemberBean(){
		this.memNo="";
		this.memName="";
		this.memGender="";
		this.memBirthday="";
		this.memPref="";
		this.memEmail="";
		this.memTel="";
		this.memLevel="";
		
		this.memberDAO=null;
	}
	public MemberBean(Context context){
		this();
		this.memberDAO=new MemberProvDAO(context);
	}
	public MemberBean(Context context,String memNo){
		this(context);
		this.memInquiry(memNo);
	}
	public void setMemNo(String no){this.memNo=no;}
	public void setMemName(String name){this.memName=name;}
	public void setMemGender(String gender){this.memGender=gender;}
	public void setMemBirthday(String birthday){this.memBirthday=birthday;}
	public void setMemPref(String pref){this.memPref=pref;}
	public void setMemEmail(String email){this.memEmail=email;}
	public void setMemTel(String tel){this.memTel=tel;}
	public void setMemLevel(String lv){this.memLevel=lv;}
	
	public String getMemNo(){return this.memNo;}
	public String getMemName(){return this.memName;}
	public String getMemGender(){return this.memGender;}
	public String getMemBirthday(){return this.memBirthday;}
	public String getMemPref(){return this.memPref;}
	public String getMemEmail(){return this.memEmail;}
	public String getMemTel(){return this.memTel;}
	public String getMemLevel(){return this.memLevel;}

	public int memRegist(){
		MemberDTO dto=new MemberDTO();
		dto.setMemNo(this.memNo);
		dto.setMemName(this.memName);
		dto.setMemGender(this.memGender);
		dto.setMemBirthday(this.memBirthday);
		dto.setMemPref(this.memPref);
		dto.setMemEmail(this.memEmail);
		dto.setMemTel(this.memTel);
		dto.setMemLevel(this.memLevel);
		return this.memberDAO.insert(dto);
	}
	public int memDelete(){
		if(this.memberDAO.delete(this.memNo)==1){
			this.memNo="";
			this.memName="";
			this.memGender="";
			this.memBirthday="";
			this.memPref="";
			this.memEmail="";
			this.memTel="";
			this.memLevel="";
			return 1;
		}
		else return 0;		
	}
	public int memUpdate(){
		MemberDTO dto=new MemberDTO();
		dto.setMemNo(this.memNo);
		dto.setMemName(this.memName);
		dto.setMemGender(this.memGender);
		dto.setMemBirthday(this.memBirthday);
		dto.setMemPref(this.memPref);
		dto.setMemEmail(this.memEmail);
		dto.setMemTel(this.memTel);
		dto.setMemLevel(this.memLevel);
		return memberDAO.update(dto);
	}
	public int memInquiry(String memNo){
		MemberDTO dto=this.memberDAO.selectOne(memNo);
		if(dto.getMemNo().equals(""))return 0;
		this.memNo=dto.getMemNo();
		this.memName=dto.getMemName();
		this.memGender=dto.getMemGender();
		this.memBirthday=dto.getMemBirthday();
		this.memPref=dto.getMemPref();
		this.memEmail=dto.getMemEmail();
		this.memTel=dto.getMemTel();
		this.memLevel=dto.getMemLevel();
		return 1;
	}
	public boolean isMemExist(){
		if(this.memNo.equals("")||this.memName.equals(""))return false;
		else return true;
	}
}