package jp.gihyo.mitoma.careTimer.activity.model;

import java.util.ArrayList;

import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareBean {
	private String memNo;
	private String memName;
	private String date;
	private ArrayList<CareDTO> careMatter;
	private String helperCode;
	private String helperName;
	private CareProvDAO careDAO;
	public CareBean(){
		this.memNo="";
		this.memName="";
		this.date="";
		this.careMatter=null;
		this.helperCode="";
		this.helperName="";
	}
	public CareBean(Context context){
		this();		
		this.careDAO=new CareProvDAO(context);
	}
	public CareBean(Context context,String memNo,String date){
		this(context);
		this.careMatter=careDAO.selectSet(memNo, date);
		this.memNo=memNo;
//		this.careInit();
		if(this.careMatter.size()>=1){
			CareDTO dto=this.careMatter.get(0);
			this.memName=dto.getMemName();
			this.date=dto.getDate();
			this.helperCode=dto.getHelperCode();
			this.helperName=dto.getHelperName();
		}
	}
	public void setMemNo(String no){this.memNo=no;}
	public void setMemName(String name){this.memName=name;}
	public void setDate(String date){this.date=date;}
	public void setCareMatter(ArrayList<CareDTO> array){this.careMatter=array;}
	public void setHelperCode(String code){this.helperCode=code;}
	public void setHelperName(String name){this.helperName=name;}
	
	public String getMemNo(){return this.memNo;}
	public String getMemName(){return this.memName;}
	public String getDate(){return this.date;}
	public ArrayList<CareDTO> getCareMatter(){return this.careMatter;}
	public String getHelperCode(){return this.helperCode;}
	public String getHelperName(){return this.helperName;}
	public int careRegist(){
		careDAO.deleteSet(this.memNo, this.date);
		careDAO.insertSet(this.careMatter);
		return 0;
	}
	public int careDelete(){
		careDAO.deleteAll();
		return 0;
	}
	public int careUpdate(){		
		return careDAO.updateSet(careMatter);
	}
	public int careInquiry(String memNo,String date){
		this.careMatter=careDAO.selectSet(memNo, date);
		int ret=this.careMatter.size();
		if(ret>=1){
			CareDTO dto=this.careMatter.get(0);
			this.memNo=dto.getMemNo();
			this.memName=dto.getMemName();
			this.date=dto.getDate();
			this.helperCode=dto.getHelperCode();
			this.helperName=dto.getHelperName();
		}
    	return ret;
	}
	public ArrayList<CareDTO> getPlanGroup(String date){		
		return this.careDAO.selectGroup("date='"+date+"'");
	}
	
	public boolean isCareExist(){
		if(this.memNo.equals("")||this.memName.equals(""))return false;
		else if(this.careMatter==null)return true;
		else if(this.careMatter.size()<1)return true;
		else return true;
	}
}