package jp.gihyo.mitoma.careWalkV01;

import java.util.Calendar;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import jp.gihyo.mitoma.careWalkV01.model.WalkDTO;
import jp.gihyo.mitoma.careWalkV01.model.WalkMainte;
import jp.gihyo.mitoma.careWalkV01.model.WalkBean;
import jp.gihyo.mitoma.careWalkV01.view.WalkView;
import jp.gihyo.mitoma.carewalk.R;
import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class WalkControl extends MapActivity{
	private WalkView walkView;
	private WalkBean walkBean;
	private WalkMainte walkMainte;
	private String date;
	private String memNo;
	private String memName;
	private String planNo;
	private String helperCode;
	private String helperName;
     @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //ʂ̏ʒuvt@X擾
        float lati=Float.parseFloat(WalkPreference.getLatitude(this));
        float longi=Float.parseFloat(WalkPreference.getLongitude(this));        
        GeoPoint point=new GeoPoint((int)(lati*1E6),(int)(longi*1E6));
        //ʂ̕\
        walkView=new WalkView(this,point);
        walkView.setSatellite(WalkPreference.isSatellite(this));
        walkMainte=new WalkMainte(this);
     	//Jڌ瑗ꂽIntent̉ԍƉo
        Intent intent=getIntent();
        this.memNo=intent.getStringExtra("memNo");
        this.memName=intent.getStringExtra("memName");
        this.date=intent.getStringExtra("date");
        this.planNo=intent.getStringExtra("planNo");
        this.helperCode=intent.getStringExtra("helperCode");
        this.helperName=intent.getStringExtra("helperName");
        //CegȂ̂Ƃ̉l̐ݒ
        if(this.memNo==null)this.memNo="100000";
        if(this.memName==null)this.memName="Android";
        if(this.date==null)this.date=(String) DateFormat.format("yyyy/MM/dd",Calendar.getInstance());
        if(this.planNo==null)this.planNo="1000";
        if(this.helperCode==null)this.helperCode="201288";
        if(this.helperName==null)this.helperName="Zp]_";
      }
     @Override
     public void onResume() {
         super.onResume();
         //vt@XɎw肳ꂽ\[hւ̐؂ւ
         walkView.setSatellite(WalkPreference.isSatellite(this));
         walkView.setMemNo(this.memNo);
         walkView.setMemName(this.memName);
         walkView.setDate(this.date);
         walkView.setPlanNo(this.planNo);
      }
     @Override
     public void onPause() {
         super.onPause();         
      }
     /* *********************************************
      * IvVj[̍쐬
      ************************************************/
     @Override
 	public boolean onCreateOptionsMenu(android.view.Menu menu) {
 	  	super.onCreateOptionsMenu(menu);
 	  	MenuInflater inflater = getMenuInflater();
 	  	inflater.inflate(R.menu.main, menu);
 	  	return true;
 	}
     /* *********************************************
      * IvVj[Cxg
      ************************************************/ 
   	@Override
   	public boolean onOptionsItemSelected(MenuItem item) {
   		
   	  	super.onOptionsItemSelected(item);
   	  	switch (item.getItemId()){
   	  	//ݒ
   	  	case R.id.optMenu_preferences:
	  		Intent intent = new Intent(this, jp.gihyo.mitoma.careWalkV01.WalkPreference.class);
			startActivity(intent);
	  		break;
	  	//DB
   	  	case R.id.optmenu_dbinit:
   	  		walkMainte.dbClear();
   	  		break;
   	  	//
   	  	case R.id.optmenu_close:
   	  		finish();
   	  		break;
   	  	}	  	
   	  	return true;
   	}
    public void onTouch(View v) {
    }
    /* *********************************************
     * {^^b`Cxg
     ************************************************/
    public void onClick(View v) {
    	//ʏ
    	int id=v.getId();
    	this.date=walkView.getDate();
    	this.planNo=walkView.getPlanNo();
    	Intent intent=new Intent("jp.gihyo.mitoma.carewalk.LOCATIONSERVICE");
    	WalkDTO dto;
    	GeoPoint point;
    	int lati,longi;
    	switch(id){
    		//WJn
    		case R.id.start:
    			intent.putExtra("memNo", this.memNo);
    			intent.putExtra("memName", this.memName);
    			intent.putExtra("date", this.date);
    			intent.putExtra("planNo", this.planNo);
    			intent.putExtra("helperCode", this.helperCode);
    			intent.putExtra("helperName", this.helperName);
    			startService(intent);
    			break;
    		//WI
    		case R.id.stop:
    			stopService(intent);
    			break;
    		//W̕\
    		case R.id.query:
    			this.walkBean=new WalkBean(this,this.memNo,this.date,this.planNo);
    			if(this.walkBean.getLocationList().size()<1)showDialog(this,"","w̋L^͂܂");
    			for(int i=0;i<this.walkBean.getLocationList().size();i++){    				
    				dto=this.walkBean.getLocationList().get(i);
    				lati=(int)(Float.parseFloat(dto.getLatitude())*1E6);
    				longi=(int)(Float.parseFloat(dto.getLongitude())*1E6);
    				point=new GeoPoint(lati,longi);
    				if(i==0)this.walkView.getMapControl().animateTo(point);
    				this.walkView.setMarker(point);
    			}
    			break;
    		//W̍폜
    		case R.id.delete:    			
    			this.walkBean.walkDelete(this.memNo,this.date,this.planNo);
    	}
    }
    /* *********************************************
     * ArrayListwsCareDTȎSڂ܂Ƃ߂ĕ\
     ************************************************/
	@Override
	protected boolean isRouteDisplayed() {
		// TODO ꂽ\bhEX^u
		return false;
	}
	public static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
}