package jp.gihyo.mitoma.intentTester;

import java.util.List;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.net.Uri;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

public class IntentCont extends Activity{
    private InentView view;
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        this.view=new InentView(this);
        this.view.setContextMenu();
    }
    //ReLXgj[\
	@Override
	public void onCreateContextMenu(ContextMenu menu,View v,ContextMenuInfo info) {
	  	super.onCreateContextMenu(menu,v,info);
	  	MenuInflater inflater = getMenuInflater();	  	
	  	inflater.inflate(R.menu.context, menu);  	
	}
	//ReLXgCxg
	@Override
	public boolean onContextItemSelected(MenuItem item) {
	  	super.onContextItemSelected(item);
	  	String action;	  		
  		String pkg;
  		String cls;
  		String cat;
  		String data;
  		String extras;
        Intent intent=new Intent();
        Uri uri;        
	  	try{
	  		//ʃf[^荞
	  		view.setResult("");
	  		action=view.getAction();
	  		data=view.getData();
	  		cat=view.getCategory();
	  		pkg=view.getPkg();	  				
	  		cls=view.getCls();
	  		extras=view.getExtras();
	  		if(!action.equals("ݒȂ")&&!action.equals(""))intent.setAction(action);
	  		if(!cat.equals("ݒȂ")&&!cat.equals(""))intent.addCategory(cat);
	        if(!data.equals("")){
	        	uri=Uri.parse(data);
	        	intent.setData(uri);}
	        if(!pkg.equals("")&&!cls.equals("")){
	        	intent.setComponent(new ComponentName(pkg,cls));
	        }
	        //Ceg̔s
	        switch (item.getItemId()){
			  	case R.id.menu_activity:
			  		Toast.makeText(this, "Activity֔s",Toast.LENGTH_SHORT).show();		  		
			        this.startActivity(intent);
			        view.setResult("startActivity Complete");
			  		break;
			  	case R.id.menu_server:
			  		Toast.makeText(this, "Server֔s",Toast.LENGTH_SHORT).show();
			  		this.startService(intent);
			  		view.setResult("startService Complete");
			  		break;
			  	case R.id.menu_receiver:
			  		Toast.makeText(this, "Receiver֔s",Toast.LENGTH_SHORT).show();
			  		this.sendBroadcast(intent);
			  		view.setResult("sendBroadcast Complete");
			  		break;		
			  	case R.id.menu_list:
			  		Toast.makeText(this, "ΏۃAv̈ꗗ",Toast.LENGTH_SHORT).show();
			  		PackageManager pm=getPackageManager();
			  		List<ResolveInfo> ril=pm.queryIntentActivities(intent, 0);
			  		ResolveInfo ri;
			  		if(ril==null)break;
			  		String buf="";
			  		for(int i=0;i<ril.size();i++){
			  			ri=ril.get(i);
			  			String pk=ri.activityInfo.packageName;
			  			String cl=ri.activityInfo.name;
			  			buf=buf+(i+1+" "+pk+"/"+cl+"\n");
			  		}
			  		view.setResult(buf);
			  		break;
		  	}
	  	}	catch(Exception e){
	  		view.setResult(e.getMessage());
	  	}	  	
	  	return true;
	}
    public void onTouch(View v) {     	
    	view.dialogInput(v);    	
    }
}