package jp.gihyo.mitoma.careMedicalV01;
import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.mitoma.careMedicalV01.model.MedicalBean;
import jp.gihyo.mitoma.careMedicalV01.model.MedicalMainte;
import jp.gihyo.mitoma.careMedicalV01.view.MedicalView;
import jp.gihyo.mitoma.caremedical.R;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.text.format.DateFormat;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MedicalControl extends Activity  implements OnInitListener{
	private MedicalView medView;
	private MedicalBean medBean;
	private MedicalMainte careMainte;
	private String date;
	private String time;
	private String memNo;
	private String memName;
	private String planNo;
	private int iTag;	
	private String inputText="";
	private TextToSpeech tts;
    private boolean ttsAvailable;
    
     @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //̓tҏW
        medView=new MedicalView(this);
        Calendar now = Calendar.getInstance();
     	this.date=(String)DateFormat.format("yyyy/MM/dd",now);
     	this.time=(String)DateFormat.format("kk:mm",now);
     	//Jڌ瑗ꂽIntent̉ԍƉo
        Intent intent=getIntent();
        this.memNo=intent.getStringExtra("memNo");
        this.memName=intent.getStringExtra("memName");
        this.planNo=intent.getStringExtra("planNo");
        //IntentȂ̂Ƃ̎blݒ
        if(this.memNo==null)this.memNo="100000";
        if(this.memName==null)this.memName="Android";
        if(this.planNo==null)this.planNo="";        
        this.tts=new TextToSpeech(this,this);
     }
     
     @Override
     public void onResume() {
         super.onResume();
         //ʂ̕\
         medBean=new MedicalBean(this,this.memNo,this.date,this.planNo);
         viewOutput();
         medView.setMemNo(this.memNo);
         medView.setMemName(this.memName);
         medView.setDate(this.date);
         medView.setTime(this.time);
      }
     
     @Override
     public void onPause() {
         super.onPause();         
      }
     @Override
     public void onDestroy() {
         super.onDestroy();
         //̃Vbg_E
         if(this.ttsAvailable){
        	 this.ttsAvailable=false;
        	 this.tts.shutdown();
         }
      }
     /* *********************************************
      * IvVj[̍쐬
      ************************************************/
     @Override
 	public boolean onCreateOptionsMenu(android.view.Menu menu) {
 	  	super.onCreateOptionsMenu(menu);
 	  	MenuInflater inflater = getMenuInflater();
 	  	inflater.inflate(R.menu.main, menu);
 	  	return true;
 	}
     /* *********************************************
      * IvVj[Cxg
      ************************************************/ 
   	@Override
   	public boolean onOptionsItemSelected(MenuItem item) {
   		
   	  	super.onOptionsItemSelected(item);
   	  	switch (item.getItemId()){
   	  	//ύX
   		case R.id.optmenu_member:
    		Intent intent=new Intent("jp.gihyo.mitoma.careMember.LIST_VIEW");
	  		startActivityForResult(intent,0);
    		break;
    	//DB    		
   	  	case R.id.optmenu_dbinit:
   	  		this.careMainte=new MedicalMainte(this);
   	  		careMainte.dbClear();
   	  		break;
   	  	//I
   	  	case R.id.optmenu_close:
   	  		finish();
   	  		break;
   	  	}	  	
   	  	return true;
   	}
    /* *********************************************
     * ڂ̃^b`ɂ鉹
     ************************************************/
    public void onTouch(View v) {
    	try{
     	final String[] list=this.getResources().getStringArray(R.array.medical_list);
    	this.iTag=Integer.parseInt((String) v.getTag());
    	Intent intent=new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
  		intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
  		intent.putExtra(RecognizerIntent.EXTRA_PROMPT, list[this.iTag]);
  		this.startActivityForResult(intent, 1000+this.iTag);
    	}catch(Exception e){
    		//G[
    	}
    }
    /* *********************************************
     * ̖͂߂菈
     ************************************************/
	@Override
    protected void onActivityResult(int reqCode,int resultCode,Intent intent){		
    	if(reqCode>=1000 && resultCode==RESULT_OK){
    		ArrayList<String> voice=intent.getStringArrayListExtra
    				(RecognizerIntent.EXTRA_RESULTS);
    		this.inputText=voice.get(0);
    	}
    	//NGXgR[hɂ鍀ڂւ̊U
    	switch(reqCode){
    		case 1000:
    			medView.setPlanNo(this.inputText);
    			break;
    		case 1001:
    			medView.setBloodU(this.inputText);
    			break;
    		case 1002:
    			medView.setBloodL(this.inputText);
    			break;
    		case 1003:
    			medView.setPulse(this.inputText);
    			break;
       		case 1004:
       			medView.setHeight(this.inputText);
    			break;
    		case 1005: 
    			medView.setWeight(this.inputText);
    			break; 
    		case 1006:
    			medView.setObserv(this.inputText);
    			break;    	
    	}
    	if(reqCode==0 && resultCode==RESULT_OK){
    		this.memNo=intent.getStringExtra("memNo");
    		this.memName=intent.getStringExtra("memName");
            medBean=new MedicalBean(this,this.memNo,this.date,"");
            viewOutput();
            medView.setMemNo(this.memNo);
            medView.setMemName(this.memName);
            medView.setDate(this.date);
            medView.setTime(this.time);
    	}
    }
    /* *********************************************
     * {^^b`Cxg
     ************************************************/
    public void onClick(View v) {
    	int id=v.getId();
    	switch(id){
    	//ǉ
    	case R.id.insert:
   			/* ***********************************************
    		 * Ƀvԍ_ũ`FbN
    		 **************************************************/
    		viewInput();   			
    		medBean.medRegist();
    		break;
    	//ύX
    	case R.id.update:   			
    		viewInput();   			
    		if(medBean.medUpdate()!=1){
    			/* ***********************************************
        		 * G[(Yf[^Ȃ)        		 
        		 **************************************************/
    		}    		
    		break;
    		//ύX
    	case R.id.query:   				
    		if(medBean.medInquiry(medView.getMemNo(), medView.getDate(), medView.getPlanNo())!=1){
    			/* ***********************************************
        		 * G[(Yf[^Ȃ)        		 
        		 **************************************************/
    		}else{
    			viewOutput();
    		}
    	break;	
    	//ǂݏグ
    	case R.id.speak:
    		if(!medView.getBloodU().equals(""))speaker("",medView.getBloodU());
    		if(!medView.getBloodL().equals(""))speaker("",medView.getBloodL());
    		if(!medView.getPulse().equals(""))speaker("",medView.getPulse());
    		if(!medView.getHeight().equals(""))speaker("g",medView.getHeight()+"Z`");
    		if(!medView.getWeight().equals(""))speaker("̏d",medView.getWeight()+"L");
    	 	if(!medView.getObserv().equals(""))speaker("",medView.getObserv());
    	}
    }
    /* *********************************************
     * \bh
     ************************************************/
    private void speaker(String voice1,String voice2){
    	if(this.ttsAvailable){
    		this.tts.speak(voice1,TextToSpeech.QUEUE_ADD, null);
    		this.tts.speak(voice2,TextToSpeech.QUEUE_ADD, null);
    	}
    }
    /* *********************************************
     * ʂ̓er[Ɏ荞
     ************************************************/
    public void viewInput(){
    	this.medBean.setDate(this.medView.getDate());
    	this.medBean.setTime(this.medView.getTime());
    	this.medBean.setPlanNo(this.medView.getPlanNo());
    	this.medBean.setBloodU(this.medView.getBloodU());
    	this.medBean.setBloodL(this.medView.getBloodL());
    	this.medBean.setPulse(this.medView.getPulse());
    	this.medBean.setHeight(this.medView.getHeight());
    	this.medBean.setWeight(this.medView.getWeight());
    	this.medBean.setObserv(this.medView.getObserv());    	
    }
    /* *********************************************
     * r[ʂɕ\
     ************************************************/
    public void viewOutput(){
    	this.medView.setDate(this.medBean.getDate());
    	this.medView.setTime(this.medBean.getTime());
    	this.medView.setPlanNo(this.medBean.getPlanNo());
    	this.medView.setBloodU(this.medBean.getBloodU());
    	this.medView.setBloodL(this.medBean.getBloodL());
    	this.medView.setPulse(this.medBean.getPulse());
    	this.medView.setHeight(this.medBean.getHeight());
    	this.medView.setWeight(this.medBean.getWeight());
    	this.medView.setObserv(this.medBean.getObserv());    	
    }
    /* *********************************************
     * o̓CjVG[^(K{\bh)
     ************************************************/
	public void onInit(int status) {
		if(status==TextToSpeech.SUCCESS){
			this.tts.speak("o͂Jn܂",TextToSpeech.QUEUE_FLUSH, null);
			this.ttsAvailable=true;
		}else{
			//_CAO̕\()ǎ҂łlB
		}		
	}    
}