package jp.gihyo.mitoma.careMember.model;

import java.util.ArrayList;

import jp.gihyo.mitoma.careMember.PreferencesCont;
import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberMainte{
	private Context context;
	private MemberDAOInterface fileDAO;
	public MemberMainte(Context context){
		this.context=context;
		String storage=PreferencesCont.getStorage(this.context);
		String saveCode=PreferencesCont.getSaveCode(this.context);
		this.fileDAO=new MemberFileDAO(this.context,storage,"member.txt",saveCode);		
	}
	 /* *********************************************
     *@DB̃t@Cޔ
     ************************************************/
	public int saveToFile(){
		MemberDAOInterface dbDAO=new MemberProvDAO(this.context);
		ArrayList<MemberDTO> list=dbDAO.selectSome(null);
		fileDAO.deleteAll();
		return fileDAO.insertSome(list);
	}
	 /* *********************************************
     *@DB̃t@C̕
     ************************************************/
	public int restoreFromFile(){
		MemberDAOInterface dbDAO=new MemberProvDAO(this.context);
		ArrayList<MemberDTO> list;
		MemberDTO dto;
		dbDAO.deleteAll();
		list=fileDAO.selectSome(null);
		if(list==null)return -1;
		int i=0;
		for(i=0;i<list.size();i++){
			 dto=list.get(i);			
			 dbDAO.insert(dto);
		}
		return i;
	}
	/* *********************************************
     *@DB̃NA
     ************************************************/
	public int dbClear(){
		MemberDAOInterface dbDAO=new MemberProvDAO(this.context);
		dbDAO.deleteAll();
		String resource=PreferencesCont.getResource(this.context);
		String saveCode=PreferencesCont.getSaveCode(this.context);
		if(resource.equals("non")||resource.equals("0"))return 0;
		MemberResDAO resDAO=new MemberResDAO(this.context,resource,"member",saveCode);		
		ArrayList<MemberDTO> list=resDAO.selectSome(null);
		MemberDTO dto;
		if(list==null)return -1;
		int i=0;
		for(i=0;i<list.size();i++){
			 dto=list.get(i);			
			 dbDAO.insert(dto);
		}
		return i;
		
	}
	/* *********************************************
     *@t@C̃NA
     ************************************************/
	public int fileClear(){
		return fileDAO.deleteAll();
	}
}