package jp.gihyo.mitoma.careMember;

import jp.gihyo.mitoma.careMember.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberView{
	private Activity act;
	private EditText memNo;
	private EditText memName;
	private TextView memGender;
	private TextView memBirthday;
	private TextView memPref;
	private EditText memEmail;
	private EditText memTel;
	private Spinner memLevel;
	private Button button;
    public MemberView(Activity obj) {
        act=obj;
        act.requestWindowFeature(Window.FEATURE_NO_TITLE);
        act.setContentView(R.layout.main);
        memNo=(EditText)act.findViewById(R.id.memNo);
        memName=(EditText)act.findViewById(R.id.memName);
        memGender=(TextView)act.findViewById(R.id.memGender);
        memBirthday=(TextView)act.findViewById(R.id.memBirthday);
        memPref=(TextView)act.findViewById(R.id.memPref);
        memEmail=(EditText)act.findViewById(R.id.memEmail);
        memTel=(EditText)act.findViewById(R.id.memTel);
        memLevel=(Spinner)act.findViewById(R.id.memLevel);
        button=(Button)act.findViewById(R.id.inputComplete);
    }
    public String getMemNo(){return memNo.getText().toString();}
    public String getMemName(){return memName.getText().toString();}
    public String getMemGender(){return memGender.getText().toString();}
    public String getMemBirthday(){return memBirthday.getText().toString();}
    public String getMemPref(){return memPref.getText().toString();}
    public String getMemEmail(){return memEmail.getText().toString();}
    public String getMemTel(){return memTel.getText().toString();}
    public String getMemLevel(){return memLevel.getSelectedItem().toString();}
      
    public void setMemNo(String no){memNo.setText(no);}
    public void setMemName(String name){memName.setText(name);}
    public void setMemGender(String gen){memGender.setText(gen);}
    public void setMemBirthday(String day){memBirthday.setText(day);}
    public void setMemPref(String pref){memPref.setText(pref);}
    public void setMemEmail(String email){memEmail.setText(email);}
    public void setMemTel(String pw){memTel.setText(pw);}
    public void setMemLevel(String l){memLevel.setSelection(selectNo(l));}
     
    public void setContextMenu(){act.registerForContextMenu(button);}
    
    public void dialogInput(View v){
    	switch(v.getId()){
    	case R.id.memGender:
    		final String[] gender=act.getResources().getStringArray(R.array.gender);
    		new AlertDialog.Builder(act)
    		.setIcon(R.drawable.icon)
    		.setTitle(R.string.genTitle)
    		.setItems(gender, new DialogInterface.OnClickListener() {				
				public void onClick(DialogInterface dialog, int which) {
					memGender.setText(gender[which]);				
				}
			})
    		.show();
    		break;
    	case R.id.memBirthday:
    		DatePickerDialog dateDialog=new DatePickerDialog(act,new DatePickerDialog.OnDateSetListener(){
    			public void onDateSet(DatePicker view,int yy,int mm,int dd){
    				memBirthday.setText(yy+"/"+(mm+1)+"/"+dd);
    			}
			},2000,0,1);
    		dateDialog.setTitle("̒a");
    		dateDialog.show();
    		break;
    	case R.id.memPref:
    		final String[] pref=act.getResources().getStringArray(R.array.prefecture);
    		new AlertDialog.Builder(act)
    		.setIcon(R.drawable.icon)
    		.setTitle(R.string.prefTitle)
    		.setItems(pref, new DialogInterface.OnClickListener() {				
				public void onClick(DialogInterface dialog, int which) {
					memPref.setText(pref[which]);				
				}
			})
    		.show();
    		break;
    	}
    }
    private int selectNo(String arg){
    	final String[] ddl=this.act.getResources().getStringArray(R.array.levelList);
    	int i;
    	for(i=0;i<ddl.length;i++){
    		if(ddl[i].equals(arg))break;
    	}
    	if(i>=ddl.length)i=0;
    	return i;
    }    
}