package jp.gihyo.mitoma.careMember.model;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class HttpComm implements Runnable{
	private Thread thread;
	private String url;
	private String path;
	private ArrayList<NameValuePair> params;
	private Handler handler;
    public HttpComm(String url){
     	this.url = url;    	
    }    
    public int start(String path,ArrayList<NameValuePair> params,Handler handler){
    	this.handler=handler;
    	this.path=path;
    	this.params=params;
        if(thread==null){
    		thread=new Thread(this);
    		thread.start();
    		return 1;
        }else return -1;
     }
	public void run() {
		ArrayList<String> response=new ArrayList<String>();
		try{			
			String record;
			DefaultHttpClient client = new DefaultHttpClient();
            HttpPost httpPost = new HttpPost(url+"/"+path);
            httpPost.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
            HttpResponse httpResponse = client.execute(httpPost);
            int statusCode = httpResponse.getStatusLine().getStatusCode();
            HttpEntity entity = httpResponse.getEntity();

            InputStream is=entity.getContent();            
            InputStreamReader sr=new InputStreamReader(is,"Shift_JIS");
            BufferedReader br=new BufferedReader(sr);
            boolean eof=false;
            while(!eof){
            	record=br.readLine();
            	if(record!=null){
            		response.add(record);
            	}else{
            		eof=true;
            	}
            }
            entity.consumeContent();
            client.getConnectionManager().shutdown();
            if(handler!=null){
	            Message msg=this.handler.obtainMessage();
	            Bundle bundle=new Bundle();
	            bundle.putStringArrayList("RESPONSE", response);
	            msg.setData(bundle);
	            handler.sendMessage(msg);
            }
            this.thread=null;
		}catch(Exception e){
			
		}		
	}
	public ArrayList<String> startNoThread(String path,ArrayList<NameValuePair> params){
		ArrayList<String> response=new ArrayList<String>();
		try{
			String record;
			DefaultHttpClient client = new DefaultHttpClient();
            HttpPost httpPost = new HttpPost(url+"/"+path);
            httpPost.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
            HttpResponse httpResponse = client.execute(httpPost);
            int statusCode = httpResponse.getStatusLine().getStatusCode();
            HttpEntity entity = httpResponse.getEntity();

            InputStream is=entity.getContent();            
            InputStreamReader sr=new InputStreamReader(is,"Shift_JIS");
            BufferedReader br=new BufferedReader(sr);
            boolean eof=false;
            while(!eof){
            	record=br.readLine();
            	if(record!=null){
            		response.add(record);
            	}else{
            		eof=true;
            	}
            }
            entity.consumeContent();
            client.getConnectionManager().shutdown();
            return response;
		}catch(Exception e){ 
			return null;
		}	
	}
}

