package jp.gihyo.mitoma.careMember.model;
import java.util.ArrayList;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import jp.gihyo.mitoma.careMember.PreferencesCont;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.Handler;
import android.os.Message;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberWebDAO implements MemberDAOInterface{
	private Context context;
	private boolean otherThread=true;
	private HttpComm httpComm;
	private ProgressDialog dialog;
	private final Handler defautHandler=new Handler(){
		public void handleMessage(Message msg){
			dialog.dismiss();
		}
	};
	private String URL;
	private final static String SELECT_PATH="caremember/select.php";
	private final static String INSERT_PATH="caremember/insert.php";
	private final static String DELETE_PATH="caremember/delete.php";
	private final static String UPDATE_PATH="caremember/update.php";
    public MemberWebDAO(Context context){ 
    	this.context=context;
    	this.URL="http://"+PreferencesCont.getServer(context);
    	this.httpComm=new HttpComm(this.URL);
		this.dialog=new ProgressDialog(context);
	    this.dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
	    this.dialog.setTitle("T[oʐM");
	    this.dialog.setMessage("CT[oƒʐMł");
	    this.URL=PreferencesCont.getServer(context);
    }
    public MemberWebDAO(Context context,boolean otherThread){
    	this(context);
		this.otherThread=otherThread;		
    }
    public MemberDTO selectOne(String key){
    	ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("subject", "CareMember"));
        params.add(new BasicNameValuePair("body", "Query"));
        params.add(new BasicNameValuePair("securecode",PreferencesCont.getSecureCode(context)));
        params.add(new BasicNameValuePair("memno",key));
        if(this.otherThread){
    		this.dialog.show();
    		httpComm.start(SELECT_PATH, params, this.defautHandler);
    		return null; 
    	}else{
    		ArrayList<String> resp=httpComm.startNoThread(SELECT_PATH, params);
    		MemberDTO dto=new MemberDTO();
    		if(resp!=null){
    			dto.setMemNo(resp.get(0));
    			dto.setMemName(resp.get(1));
    	        dto.setMemGender(resp.get(2));
    	        dto.setMemBirthday(resp.get(3));
    	        dto.setMemPref(resp.get(4));
    	        dto.setMemEmail(resp.get(5));
    	        dto.setMemTel(resp.get(6));
    	        dto.setMemLevel(resp.get(7));
    	        dto.setMemLatitude(resp.get(8));
    	        dto.setMemLongitude(resp.get(9));
    			return dto;
    		}
    		return null;
    	}       
    }
    public MemberDTO selectOne(String key,Handler handler){
    	ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("subject", "CareMember"));
        params.add(new BasicNameValuePair("body", "query"));
        params.add(new BasicNameValuePair("securecode",PreferencesCont.getSecureCode(context)));
        params.add(new BasicNameValuePair("memno",key));
        if(this.otherThread){
    		this.dialog.show();
    		httpComm.start(SELECT_PATH, params, handler);
    		return null; 
    	}else{
    		ArrayList<String> resp=httpComm.startNoThread(SELECT_PATH, params);
    		MemberDTO dto=new MemberDTO();
    		if(resp!=null){
    			dto.setMemNo(resp.get(0));
    			dto.setMemName(resp.get(1));
    	        dto.setMemGender(resp.get(2));
    	        dto.setMemBirthday(resp.get(3));
    	        dto.setMemPref(resp.get(4));
    	        dto.setMemEmail(resp.get(5));
    	        dto.setMemTel(resp.get(6));
    	        dto.setMemLevel(resp.get(7));
    	        dto.setMemLatitude(resp.get(8));
    	        dto.setMemLongitude(resp.get(9));
    			return dto;
    		}
    		return null;
    	}       
    }    
    public ArrayList<MemberDTO> selectSome(String[] terms){
    	return null;
    }
    public int delete(String key){
    	ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("subject", "CareMember"));
        params.add(new BasicNameValuePair("body", "delete"));
        params.add(new BasicNameValuePair("securecode",PreferencesCont.getSecureCode(context)));
        params.add(new BasicNameValuePair("memno",key));
        if(this.otherThread){
    		this.dialog.show();
    		httpComm.start(SELECT_PATH, params, this.defautHandler);
    	}else{
    		ArrayList<String> resp=httpComm.startNoThread(DELETE_PATH, params);
    		if(resp!=null){
    			if(resp.size()>=1){
    				if(resp.get(0).equals("OK"))return 1;
    			}
    		}
    		return -1;
    	}
		return 0;
    }
    public int deleteAll(){    	
    	return 0;
    }
    public int insert(MemberDTO dto){
    	ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("subject", "CareMember"));
        params.add(new BasicNameValuePair("body", "delete"));
        params.add(new BasicNameValuePair("securecode",PreferencesCont.getSecureCode(context)));
        params.add(new BasicNameValuePair("memno",dto.getMemNo()));
        params.add(new BasicNameValuePair("memname",dto.getMemName()));
        params.add(new BasicNameValuePair("gender",dto.getMemGender()));
        if(this.otherThread){
    		this.dialog.show();
    		httpComm.start(SELECT_PATH, params, this.defautHandler);
    		return 0;
    	}else{
    		ArrayList<String> resp=httpComm.startNoThread(INSERT_PATH, params);
    		if(resp!=null){
    			if(resp.size()>=1){
    				if(resp.get(0).equals("OK"))return 1;
    			}
    		}
    		return -1;
    	}
    }
    public int update(MemberDTO dto){
    	ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("subject", "CareMember"));
        params.add(new BasicNameValuePair("body", "delete"));
        params.add(new BasicNameValuePair("securecode",PreferencesCont.getSecureCode(context)));
        params.add(new BasicNameValuePair("memno",dto.getMemNo()));
        params.add(new BasicNameValuePair("memname",dto.getMemName()));
        params.add(new BasicNameValuePair("gender",dto.getMemGender()));
        if(this.otherThread){
    		this.dialog.show();
    		httpComm.start(UPDATE_PATH, params, this.defautHandler);
    		return 0;
    	}else{
    		ArrayList<String> resp=httpComm.startNoThread(UPDATE_PATH, params);
    		if(resp!=null){
    			if(resp.size()>=1){
    				if(resp.get(0).equals("OK"))return 1;
    			}
    		}
    		return -1;
    	}
    }
    public int insertSome(ArrayList<MemberDTO> list){
    	return 0;
    }
}
