package jp.gihyo.mitoma.careWalkV01.service;
import java.util.Calendar;
import jp.gihyo.mitoma.careWalkV01.model.WalkBean;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.location.LocationProvider;
import android.os.Bundle;
import android.os.IBinder;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.text.format.DateFormat;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
//v[[T[rX
public class WalkService extends Service implements OnInitListener, LocationListener{
    private boolean flag;
    private TextToSpeech speaker;
    private LocationManager lm;
    private String provider;
    private WalkBean walkBean;
    @Override
    public void onCreate(){
    	//KChJn
       	this.speaker=new TextToSpeech(this,this);
       	//P[VvoC_
       	this.lm=(LocationManager)getSystemService(Context.LOCATION_SERVICE);       	       	
       	this.provider=LocationManager.GPS_PROVIDER;
       	this.walkBean=new WalkBean(this);
       	flag=false;
    }
    /* *********************************************
     * X^[gCxg
     ************************************************/
    @Override
    public void onStart(Intent intent,int startID) {
    	super.onStart(intent, startID);
    	if(flag){
    		this.speaker.speak("݁@Wł",TextToSpeech.QUEUE_ADD, null);
    	}else{
    		//ʒuĎJn
    		flag=true;
    		this.walkBean.setMemNo(intent.getStringExtra("memNo"));
    		this.walkBean.setMemName(intent.getStringExtra("memName"));
    		this.walkBean.setDate(intent.getStringExtra("date"));
    		this.walkBean.setPlanNo(intent.getStringExtra("planNo"));
            this.walkBean.setHelperCode(intent.getStringExtra("helperCode"));
            this.walkBean.setHelperName(intent.getStringExtra("helperName"));      
	    	this.lm.requestLocationUpdates(this.provider, 60000, 50,this);
    	}
    }
    @Override
    public void onDestroy() {
    	super.onDestroy();
    	//ʒuĎI
       	this.lm.removeUpdates(this);
        if(this.flag){
        	//KChI
           	 this.flag=false;
           	 this.speaker.shutdown();
        }
     }
    /* *********************************************
     * KCh
     ************************************************/
	public void onInit(int status) {
		if(status==TextToSpeech.SUCCESS){
			this.speaker.speak("ɂ",TextToSpeech.QUEUE_FLUSH, null);
			this.speaker.speak("ʒu̎WJn܂",TextToSpeech.QUEUE_ADD, null);
		}		
	}
	/* *********************************************
     * ʒuړCxg
     ************************************************/
	public void onLocationChanged(Location location) {
        Calendar now = Calendar.getInstance();
     	String time=(String)DateFormat.format("kk:mm:ss",now);     	
		try{		
		 String lati=String.format("%f", location.getLatitude());
	  	 String longi=String.format("%f", location.getLongitude());
	  	 this.walkBean.setTime(time);
	  	 this.walkBean.setLatitude(lati);
	  	 this.walkBean.setLongitude(longi);
	  	 this.walkBean.walkRegist();
//	  	 this.speaker.speak("ܓx"+lati,TextToSpeech.QUEUE_ADD, null);
//	  	 this.speaker.speak("ox"+longi,TextToSpeech.QUEUE_ADD, null);
//	  	@this.speaker.speak("͎Wł",TextToSpeech.QUEUE_ADD, null);
		}catch(Exception e){}
	}
	public void onProviderDisabled(String provider) {
		// TODO ꂽ\bhEX^u
		this.speaker.speak("ʒuvoC_ItɂȂ܂",TextToSpeech.QUEUE_ADD, null);
	}
	public void onProviderEnabled(String provider) {
		// TODO ꂽ\bhEX^u
		this.speaker.speak("ʒuvoC_IɂȂ܂",TextToSpeech.QUEUE_ADD, null);
	}
	public void onStatusChanged(String provider, int status, Bundle extras) {
		if(status==LocationProvider.OUT_OF_SERVICE)
		this.speaker.speak("Oɂł܂B",TextToSpeech.QUEUE_ADD, null);
	}
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO ꂽ\bhEX^u
		return null;
	}
    
}