package jp.gihyo.mitoma.careWalkV01.view;

import java.util.List;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

import jp.gihyo.mitoma.carewalk.R;
import android.app.Activity;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.view.Window;
import android.widget.EditText;
import android.widget.TextView;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class WalkView {
	private MapActivity act;
	private MapView mapView;
	private TextView memNo;
	private TextView memName;
	private EditText date;
	private EditText planNo;
	private List<Overlay> list;
	private MapController mapControl;
    public WalkView(Object obj,GeoPoint point) {    	
        act=(MapActivity)obj;
        act.requestWindowFeature(Window.FEATURE_NO_TITLE);
        act.setContentView(R.layout.care_walk);
        mapView=(MapView)act.findViewById(R.id.map_view);
        mapControl=mapView.getController();
        list=mapView.getOverlays();
        mapView.setBuiltInZoomControls(true);
        mapControl.animateTo(point);
        mapControl.setZoom(16);
        memNo=(TextView)act.findViewById(R.id.memNo);
        memName=(TextView)act.findViewById(R.id.memName);
        date=(EditText)act.findViewById(R.id.date);
        planNo=(EditText)act.findViewById(R.id.planNo);
    }
    /* *********************************************
     * Qb^[
     ************************************************/
    public String getMemNo(){return memNo.getText().toString();}
    public String getMemName(){return memName.getText().toString();}
    public String getDate(){return date.getText().toString();}
    public String getPlanNo(){return planNo.getText().toString();}
    public MapController getMapControl(){return this.mapControl;}
    
    /* *********************************************
     * Zb^[
     ************************************************/
    public void setSatellite(boolean mode){this.mapView.setSatellite(mode);}
    public void setMemNo(String no){memNo.setText(no);}
    public void setMemName(String name){memName.setText(name);}
    public void setDate(String date){this.date.setText(date);}
    public void setPlanNo(String no){planNo.setText(no);}
    public void setMarker(GeoPoint point){
    	MapsOverlay overlay=new MapsOverlay(point);
    	list.add(overlay);
    }    
}
class MapsOverlay extends Overlay{
	private GeoPoint gPoint;
	public MapsOverlay(GeoPoint gPoint){
		this.gPoint=gPoint;
	}
	public void draw(Canvas canvas,MapView map,boolean shadow){
		super.draw(canvas,map,shadow);
		Projection projection=map.getProjection();
		Point pt=new Point();
		projection.toPixels(gPoint, pt);
		Paint paint=new Paint();
		paint.setStyle(Paint.Style.FILL);
		paint.setARGB(255, 255, 0, 0);
		canvas.drawCircle(pt.x, pt.y, 8, paint);		
	}
}